package cn.com.qmth.stmms.biz.exam.service;

import cn.com.qmth.stmms.biz.exam.model.MarkGroup;
import cn.com.qmth.stmms.biz.exam.model.Marker;
import cn.com.qmth.stmms.biz.exam.query.MarkerSearchQuery;

import java.util.List;
import java.util.Set;

public interface MarkerService {

    Marker save(Marker marker);

    Marker findById(Integer id);

    // Marker findByLoginName(String loginName);
    //
    List<Marker> findByExamAndSubjectAndGroup(int examId, String subjectCode, int groupNumber);

    long countByExam(int examId);

    // int batchCreate(ExamSubject subject, int groupNumber, int count, String
    // password);

    MarkerSearchQuery findByQuery(MarkerSearchQuery query);

    List<Marker> getMarkCount(int examId);

    long countByExamAndSubjectAndGroup(int examId, String subjectCode, int number);

    List<Marker> getMarkCount(int examId, Set<String> subjectCodes);

    List<Marker> findMode(String commo);

    // public List<Marker> findByStudentId(int studentId);

    public int batchSave(List<Marker> list);

    void updateMarkSetting(Integer id, String setting);

    List<Marker> findByExamAndUserId(Integer examId, Integer userId);

    Marker findByExamAndSubjectAndNumberAndUserId(int examId, String subjectCode, Integer number, Integer userId);

    long countByUserId(Integer userId);

    void deleteById(Integer markerId);

    void save(MarkGroup group, Integer[] userIds);

    // void updateOpenAccountById(Integer id, Integer openAccountId);

    // List<Marker> findByOpenAccountAndMarkStatus(Integer openAccountId,
    // MarkStatus... status);

    // long countByExamAndSubjectAndGroupAndOpenAccount(Integer examId, String
    // subjectCode, Integer groupNumber,
    // Integer openAccountId);
}
